package be.iminds.ilabt.jfed.espec.util;

import javax.annotation.Nonnull;
import java.util.ArrayList;
import java.util.List;

/**
 * LimitedLiveLogImpl
 *
 * TODO: correct implementation needed
 */
public class LimitedLiveLogImpl implements LimitedLiveLog {
    private final List<ChangeListener> listeners = new ArrayList();

    @Nonnull private String head;
    @Nonnull private String tail;

    private int received;
    private int limit;
    private boolean endReached;

    public LimitedLiveLogImpl() {
        this(1_000_000);
    }
    public LimitedLiveLogImpl(int limit) {
        head = "";
        tail = "";
        received = 0;
        this.limit = limit;
        endReached = false;
    }

    @Override
    public void addChangeListener(@Nonnull ChangeListener l) {
        listeners.add(l);
    }

    @Override
    public void removeChangeListener(@Nonnull ChangeListener l) {
        listeners.remove(l);
    }

    @Override
    public void appendText(@Nonnull String extraText) {
        received += extraText.length();
        if (tail.isEmpty()) {
            if (head.length() + extraText.length() > limit) {
                head += extraText; //placeholder for real functionality
                //TODO: split into head and tail, and append to tail
            } else {
                head += extraText;
            }
        } else {
            head += extraText; //placeholder for real functionality
            //TODO append to tail and discard from beginning of tail
        }
        fireChange(extraText);
    }

    private void fireChange(@Nonnull String extraText) {
        for (ChangeListener l : listeners)
            l.onChanged(this, extraText);
    }

    @Override
    public void setEndReached() {
        this.endReached = true;
        for (ChangeListener l : listeners)
            l.onEndReached(this);
    }

    @Nonnull
    @Override
    public String getText() {
        if (tail.isEmpty())
            return head;
        else
            return head + "\n...\n\n" + tail;
    }

    @Nonnull
    @Override
    public String getHeadText() {
        return head;
    }

    @Nonnull
    @Override
    public String getTailText() {
        return tail;
    }

    @Override
    public boolean isLimited() {
        return !tail.isEmpty();
    }

    @Override
    public int getReceivedSize() {
        return received;
    }

    @Override
    public int getStoredSize() {
        return head.length() + tail.length();
    }

    @Override
    public int getSizeLimit() {
        return limit;
    }

    @Override
    public boolean isEndReached() {
        return endReached;
    }
}
